;ASPECTS OF BANDLIMITING
;Ex.6, Bandlimiting using Tablekt with Midi
;uses the bandlimited tables for midi numbers
;but also uses GEN16 tables with straight line numbers
;for EACH midi note number.
;Maps midi numbers to a bandlimited table

;uses tablekt


<CsoundSynthesizer>
<CsOptions>

-+rtaudio=portaudio -odac 
;-+rtaudio=portaudio -otest.wav
csound -s -d -b4096 -B4096 

</CsOptions>
<CsInstruments>

sr	=	44100
kr	=	441
ksmps	=	100
nchnls	=	1


/* Create a rich sawtooth wave */
i_	ftgen 30000, 0, 16384, 7, 1, 16384, -1

/* generate bandlimited sawtooth waves for MIDI pitch nums */
i0	=  0
loop1:
imaxh	=  sr / (2 * 440.0 * exp (log(2.0) * (i0 - 69) / 12))
i_	ftgen i0, 0, 4096, -30, 30000, 1, imaxh
;print  imaxh
i0	=  i0 + 1
	if (i0 < 127.5) igoto loop1


;GEN16 ;create a straight line function of numbers from 1 to 128
;EX. - table 200 has 127 discrete nums across 127 values
;      table 327 has 1  discrete num across 127 values

i2  = 0
loop2:
i_	ftgen 327 - i2,  0, 128, -16, 1, 127, 0, i2
;itable =  327 - i2
;print itable, 327 - i2   
i2	= i2 + 1
	if (i2 < 127.5) igoto loop2


;===================================================
;===================================================
;===================================================
	instr 1


kmidi = 30  ;enter a midi number

;Pulse thru a table from loop2 
;once in time of p3.
;Only those bandlimited tables from loop1
;will be included.

;need tablekt to change table numbers

kphs phasor 0.043
ktable tablekt kphs * 128, kmidi + 200, 0
;printk2 round(ktable), 5

;convert midi pitch nums to hertz
kcps	=  440.0 * exp (log(2.0) * (kmidi - 69) / 12)

;add portamento for freqs if needed
;kcps    port  kcps, 0.09 
a2	oscilikt 2000, kcps, round(ktable)

out a2
	endin


</CsInstruments>
<CsScore>
i1 0 23

e
</CsScore>
</CsoundSynthesizer>
